
local splash = display.newRect(0,0,display.contentWidth,display.contentHeight)
splash.fill = { type="image", filename="splash.png" }
splash.x = display.contentCenterX
splash.y = display.contentCenterY	

local function main()
local win = false
local loose = false;
local physics = require("physics")

physics.start()
physics.setGravity(0,0)



local audio = require"AudioManager"

audio.playMusic("Rowing A Boat.mp3")

local start = true

local backGround = display.newRect(0,0,display.contentWidth,display.contentHeight)
    backGround:setFillColor(68/255, 187/255, 255/255)
backGround.x = display.contentCenterX
backGround.y = display.contentCenterY	
	


display.setStatusBar( display.HiddenStatusBar )
local Boat = require "Boat"
local Fish = require "Fish"




borderCollisionFilter = { categoryBits = 1, maskBits = 128 } 
borderBodyElement = { friction=0.4, bounce=0.8, filter=borderCollisionFilter }



local water1 = display.newRect( display.contentCenterX,display.contentCenterY,display.contentWidth, display.contentHeight)
local water2 = display.newRect( display.contentCenterX,display.contentCenterY,display.contentWidth, display.contentHeight )

-- Create container for visual objects
local myContainer = display.newContainer( display.contentWidth, display.contentHeight )
myContainer.x = display.contentCenterX 
myContainer.y = display.contentCenterY

math.randomseed(os.time())
local fish = {}
local fishCount =  math.random(1,10)
for i = 1, fishCount do 
    fish[i] = Fish:new(i, start);
    myContainer:insert(fish[i].view)
    
    fish[i].view.width = display.contentWidth / 20
    fish[i].view.height = display.contentHeight / 20

    fish[i].view.x = math.random((-display.contentWidth/2)+fish[i].view.width/2, (display.contentWidth/2)-fish[i].view.width/2)
    fish[i].view.y = math.random((-display.contentHeight/2)+fish[i].view.height/2, (display.contentHeight/2)-fish[i].view.height/2)

	fish[i].view.rotation = math.random(0, 360)
end 

-- Keep track of time in seconds
local secondsLeft = fishCount * 6 

local logo = Boat:new()
myContainer:insert(logo.view)
logo:addPhysicsBody()

logo.view.width = display.contentWidth / 2.5
logo.view.height = display.contentHeight / 2.5

logo.view.x = 0
logo.view.y = 0
logo.view:toFront()

local function remove()
        local gameOver = display.newRect( display.contentCenterX,display.contentCenterY,display.contentWidth, display.contentHeight)
        gameOver.fill = { type="image", filename="win.png" }
        gameOver.width = display.contentWidth
        gameOver.height = display.contentHeight
        gameOver.fill.rotation = 0

        audio.stopMusic("Rowing A Boat.mp3") 

        Runtime:removeEventListener("touch", createWave)
        Runtime:removeEventListener("enterFrame", update)
end

local function onCollision(event)
    win = true
    if loose == false then
        fish[event.value].view:removeSelf()
        fish[event.value].view = nil
        timer.performWithDelay(1000, remove)
    end
end

Runtime:addEventListener( "fishCollision", onCollision)

--transition.to(myContainer, {xScale = 0.5 , yScale =0.5, time = 3000})



local  waves  =  {}

-- Set defaults for repeated textures which follow
display.setDefault( "textureWrapX", "repeat" )
display.setDefault( "textureWrapY", "mirroredRepeat" )

-- Apply repeating textures and filters to objects

water2.fill = { type="image", filename="sea2.png" }
water2.width = display.contentWidth
water2.height = display.contentHeight
water2.fill.rotation = 15
water2.fill.effect = "filter.wobble"
water2.fill.effect.amplitude = 6
water2.alpha = 0.25

water1.fill = { type="image", filename="sea1.png" }
water1.width = display.contentWidth
water1.height = display.contentHeight
water1.fill.rotation = 0
water1.fill.effect = "filter.wobble"
water1.fill.effect.amplitude = 6
water1.alpha = 0.75

-- Reset texture wrap modes
display.setDefault( "textureWrapX", "clampToEdge" )
display.setDefault( "textureWrapY", "clampToEdge" )






local function repeatTrans()
	transition.to( water1.fill, { time=4000, x=water1.fill.x-0.5, onComplete=repeatTrans })
	transition.to( water2.fill, { time=4000, x=water1.fill.x-0.5 })
end
repeatTrans() 
scale = 1 

local waveCollisionFilter = { categoryBits = 2, maskBits = 1 } -- collides with (2) only
local waveBody = { density=1, friction=0, bounce=0.5, radius=100.0, filter=waveCollisionFilter }



function createWave( event )
	if ( event.phase == "ended" ) then
            audio.playEffect("Slime Splash.wav")
--		removeCircle()
                circle = display.newCircle(  event.x -display.contentCenterX , event.y - display.contentCenterY, 50 )
--		circle.anchorChildren = true
                circle.strokeWidth = 10
                circle:setStrokeColor( 0/255,100/255,200/255 )
                circle:setFillColor(0,0,0,0)
                circle.alpha = 0.5

                transition.to(circle, {time = 2000, xScale = 4.0, yScale = 4.0, alpha = 0, onComplete = removeCircle })

                myContainer:insert(circle)	
                logo.view:toFront()   
                wave()
	end
end
function removeCircle(  )
	display.remove(circle)
end

function wave()

	if (math.sqrt(math.pow(circle.x-logo.view.x, 2)+math.pow(circle.y-logo.view.y, 2)) <= 75) then
	print("%%%%%%%%%%%%%%%%%%%%")
		if (circle.x > logo.view.x and circle.y > logo.view.y) then
		logo:affectByWave(-50, -50)
	
		
		elseif (circle.x > logo.view.x and circle.y < logo.view.y) then
		logo:affectByWave(-50, 50)
		
		elseif (circle.x < logo.view.x and circle.y > logo.view.y) then
		logo:affectByWave(50, -50)
		
		elseif (circle.x < logo.view.x and circle.y < logo.view.y) then
		logo:affectByWave(50, 50)
		end
		
	elseif (math.sqrt(math.pow(circle.x-logo.view.x, 2)+math.pow(circle.y-logo.view.y, 2)) <= 150 ) then
	
		if (circle.x > logo.view.x and circle.y > logo.view.y) then
		logo:affectByWave(-25, -25)
	
		
		elseif (circle.x > logo.view.x and circle.y < logo.view.y) then
		logo:affectByWave(-25, 25)
		
		elseif (circle.x < logo.view.x and circle.y > logo.view.y) then
		logo:affectByWave(25, -25)
		
		elseif (circle.x < logo.view.x and circle.y < logo.view.y) then
		logo:affectByWave(25, 25)
		end
	
	end
    
end

function update()
  
    
    if secondsLeft == 0 and win == false then
        loose = true
        local gameOver = display.newRect( display.contentCenterX,display.contentCenterY,display.contentWidth, display.contentHeight)
        gameOver.fill = { type="image", filename="sea1.png" }
        gameOver.width = display.contentWidth
        gameOver.height = display.contentHeight
        gameOver.fill.rotation = 0
        audio.stopMusic("Rowing A Boat.mp3") 
     
        Runtime:removeEventListener("touch", createWave)
        Runtime:removeEventListener("enterFrame", update)
    end

end
 
Runtime:addEventListener( "enterFrame", update )
Runtime:addEventListener("touch", createWave)

 local upBorder = display.newRect(myContainer, 0, -display.contentHeight/2, display.contentWidth, 1)
upBorder:setFillColor(0, 0, 0, 0)
physics.addBody( upBorder, "static")

local downBoarder = display.newRect(myContainer, 0, display.contentHeight/2, display.contentWidth, 1)
downBoarder:setFillColor(0, 0, 0, 0)
physics.addBody( downBoarder, "static")

local leftBoarder = display.newRect(myContainer, -display.contentWidth/2, 0, display.contentHeight, 1)
leftBoarder:setFillColor(0, 0, 0, 0)
leftBoarder.rotation = 90
physics.addBody( leftBoarder, "static")

local rightBoarder = display.newRect(myContainer, display.contentWidth/2, 0, display.contentHeight, 1)
rightBoarder:setFillColor(0, 0, 0, 0)
rightBoarder.rotation = -90
physics.addBody( rightBoarder, "static")

display.setDefault("background", 0.2, 0.2, 0.4 )



local clockText = display.newText("", display.contentCenterX, 10, native.systemFontBold, 20)
clockText:setFillColor( 1, 0, 0 )

local function updateTime()
	-- decrement the number of seconds
	secondsLeft = secondsLeft - 1
	
	-- time is tracked in seconds.  We need to convert it to minutes and seconds
	local minutes = math.floor( secondsLeft / 60 )
	local seconds = secondsLeft % 60
	
	-- make it a string using string format.  
	local timeDisplay = string.format( "%02d:%02d", minutes, seconds )
	clockText.text = timeDisplay
end

-- run them timer
local countDownTimer = timer.performWithDelay( 1000, updateTime, secondsLeft )

physics.addBody( rightBoarder, "static") 

end

timer.performWithDelay( 5000, main )


